#!/bin/sh
#set -x

# Script to transform StarOffice6.0 (e.g sxw,sxc,sxi) to HTML
# by using our OOo XSLT stylesheets with Xerces parser and XT processor
# Used in conjunction with the URL of the Office document as only parameter
#
# Output may be redirected by shell into certain destination file


CLASSORIG=$CLASSPATH


# NOTICE! ->  adapt the directory and get jar from http://xml.apache.org/dist/xalan-j/
XALAN_DIR=../xalan-j_20020801/bin

# NOTICE! ->  adapt the directory and get jar from http://www.blnz.com/xt/index.html
XT_DIR=../xt-20020426a

# NOTICE! -> this directory is in the xmloff project
DTD_DIR=../../dtd


CLASSPATH=$CLASSPATH:${XALAN_DIR}/xercesImpl.jar:${XALAN_DIR}/xml-apis.jar:${XT_DIR}/xt.jar:

UNPACK_DIR=./testfile.$$
PARSER=org.xml.sax.helpers.XMLReaderAdapter
DRIVER=org.apache.xerces.parsers.SAXParser


usage_error()
{
	echo " "
	echo "usage:"
	echo "  $0 <office document to be transformed>"
	echo " "
}

if [ $# -gt 0 ] ; then

	if [ $# -gt 1 ] ; then
    	usage_error
		exit 1
	fi

	echo Transforming $1 >> ./log_2html.txt

	#abort if directory exists
	mkdir $UNPACK_DIR || exit
	unzip -d $UNPACK_DIR $1
	#our zip creates a zipfiles with no executable rights for Pictures dir
	find $UNPACK_DIR -type d 2>/dev/null | xargs chmod 777
	cp ./${DTD_DIR}/*.* $UNPACK_DIR
	echo $CLASSPATH  >&2
	echo "*** starting transformation ***" >&2
	java -cp $CLASSPATH -Dcom.jclark.xsl.sax.parser=$PARSER -Dorg.xml.sax.driver=$DRIVER -DJAVA.COMPILER=NONE com.jclark.xsl.sax.Driver  $UNPACK_DIR/content.xml main_html.xsl out.htm  sourceDirURL=$UNPACK_DIR metaURL=$UNPACK_DIR/meta.xml stylesURL=$UNPACK_DIR/styles.xml 1>&2
	cat out.htm
	#vi out.htm
	echo "*** finished transformation ***" >&2
	rm -rf $UNPACK_DIR

	echo "Done  " $1 >> ./log_2html.txt
	CLASSPATH=$CLASSORIG
else
    usage_error
	exit 1
fi

exit 0                                                       